require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ANSIDECL_H)) {
    eval 'sub _ANSIDECL_H () {1;}' unless defined(&_ANSIDECL_H);
    unless(defined(&GCC_VERSION)) {
	eval 'sub GCC_VERSION () {( &__GNUC__ * 1000+  &__GNUC_MINOR__);}' unless defined(&GCC_VERSION);
    }
    if(defined ( &__STDC__) || defined ( &_AIX) || (defined ( &__mips)  && defined ( &_SYSTYPE_SVR4)) || defined( &_WIN32) || (defined( &__alpha)  && defined( &__cplusplus))) {
	eval 'sub ANSI_PROTOTYPES () {1;}' unless defined(&ANSI_PROTOTYPES);
	eval 'sub PTR () { &void *;}' unless defined(&PTR);
	eval 'sub PTRCONST () { &void * &const;}' unless defined(&PTRCONST);
	eval 'sub LONG_DOUBLE () {\'long double\';}' unless defined(&LONG_DOUBLE);
	unless(defined(&PARAMS)) {
	    eval 'sub PARAMS {
	        my($ARGS) = @_;
    		eval q($ARGS);
	    }' unless defined(&PARAMS);
	}
	eval 'sub VPARAMS {
	    my($ARGS) = @_;
    	    eval q($ARGS);
	}' unless defined(&VPARAMS);
	eval 'sub VA_START {
	    my($VA_LIST, $VAR) = @_;
    	    eval q( &va_start($VA_LIST, $VAR));
	}' unless defined(&VA_START);
	eval 'sub VA_OPEN {
	    my($AP, $VAR) = @_;
    	    eval q({  &va_list $AP;  &va_start($AP, $VAR); { \'struct Qdmy\');
	}' unless defined(&VA_OPEN);
	eval 'sub VA_CLOSE {
	    my($AP) = @_;
    	    eval q(}  &va_end($AP); });
	}' unless defined(&VA_CLOSE);
	eval 'sub VA_FIXEDARG {
	    my($AP, $T, $N) = @_;
    	    eval q(\'struct Qdmy\');
	}' unless defined(&VA_FIXEDARG);
	undef(&const) if defined(&const);
	undef(&volatile) if defined(&volatile);
	undef(&signed) if defined(&signed);
	undef(&inline) if defined(&inline);
	if((defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : 0) > 199901) {
	} else {
	    if((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 2007) {
		eval 'sub inline () { &__inline__;}' unless defined(&inline);
	    } else {
		eval 'sub inline () {1;}' unless defined(&inline);
	    }
	}
	unless(defined(&IN_GCC)) {
	    eval 'sub CONST () { &const;}' unless defined(&CONST);
	    eval 'sub VOLATILE () { &volatile;}' unless defined(&VOLATILE);
	    eval 'sub SIGNED () {\'signed\';}' unless defined(&SIGNED);
	    eval 'sub PROTO {
	        my($type, $name, $arglist) = @_;
    		eval q($type $name $arglist);
	    }' unless defined(&PROTO);
	    eval 'sub EXFUN {
	        my($name, $proto) = @_;
    		eval q($name $proto);
	    }' unless defined(&EXFUN);
	    eval 'sub DEFUN {
	        my($name, $arglist, $args) = @_;
    		eval q($name($args));
	    }' unless defined(&DEFUN);
	    eval 'sub DEFUN_VOID {
	        my($name) = @_;
    		eval q($name( &void));
	    }' unless defined(&DEFUN_VOID);
	    eval 'sub AND () {,;}' unless defined(&AND);
	    eval 'sub DOTS () {, ...;}' unless defined(&DOTS);
	    eval 'sub NOARGS () { &void;}' unless defined(&NOARGS);
	}
    } else {
	undef(&ANSI_PROTOTYPES) if defined(&ANSI_PROTOTYPES);
	eval 'sub PTR () {\'char\' *;}' unless defined(&PTR);
	eval 'sub PTRCONST () { &PTR;}' unless defined(&PTRCONST);
	eval 'sub LONG_DOUBLE () {\'double\';}' unless defined(&LONG_DOUBLE);
	eval 'sub PARAMS {
	    my($args) = @_;
    	    eval q(());
	}' unless defined(&PARAMS);
	eval 'sub VPARAMS {
	    my($args) = @_;
    	    eval q(( &va_alist)  &va_dcl);
	}' unless defined(&VPARAMS);
	eval 'sub VA_START {
	    my($va_list, $var) = @_;
    	    eval q( &va_start($va_list));
	}' unless defined(&VA_START);
	eval 'sub VA_OPEN {
	    my($AP, $VAR) = @_;
    	    eval q({  &va_list $AP;  &va_start($AP); { \'struct Qdmy\');
	}' unless defined(&VA_OPEN);
	eval 'sub VA_CLOSE {
	    my($AP) = @_;
    	    eval q(}  &va_end($AP); });
	}' unless defined(&VA_CLOSE);
	eval 'sub VA_FIXEDARG {
	    my($AP, $TYPE, $NAME) = @_;
    	    eval q($TYPE $NAME =  &va_arg($AP, $TYPE));
	}' unless defined(&VA_FIXEDARG);
	undef(&const) if defined(&const);
	undef(&volatile) if defined(&volatile);
	undef(&signed) if defined(&signed);
	undef(&inline) if defined(&inline);
	eval 'sub const () {1;}' unless defined(&const);
	eval 'sub volatile () {1;}' unless defined(&volatile);
	eval 'sub signed () {1;}' unless defined(&signed);
	eval 'sub inline () {1;}' unless defined(&inline);
	unless(defined(&IN_GCC)) {
	    eval 'sub CONST () {1;}' unless defined(&CONST);
	    eval 'sub VOLATILE () {1;}' unless defined(&VOLATILE);
	    eval 'sub SIGNED () {1;}' unless defined(&SIGNED);
	    eval 'sub PROTO {
	        my($type, $name, $arglist) = @_;
    		eval q($type $name ());
	    }' unless defined(&PROTO);
	    eval 'sub EXFUN {
	        my($name, $proto) = @_;
    		eval q($name());
	    }' unless defined(&EXFUN);
	    eval 'sub DEFUN {
	        my($name, $arglist, $args) = @_;
    		eval q($name $arglist $args;);
	    }' unless defined(&DEFUN);
	    eval 'sub DEFUN_VOID {
	        my($name) = @_;
    		eval q($name());
	    }' unless defined(&DEFUN_VOID);
	    eval 'sub AND () {;;}' unless defined(&AND);
	    eval 'sub DOTS () {1;}' unless defined(&DOTS);
	    eval 'sub NOARGS () {1;}' unless defined(&NOARGS);
	}
    }
    if(((defined(&GCC_VERSION) ? &GCC_VERSION : 0) < 2007)) {
	eval 'sub __attribute__ {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&__attribute__);
    }
    unless(defined(&ATTRIBUTE_MALLOC)) {
	if(((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 2096)) {
	    eval 'sub ATTRIBUTE_MALLOC () { &__attribute__ (( &__malloc__));}' unless defined(&ATTRIBUTE_MALLOC);
	} else {
	    eval 'sub ATTRIBUTE_MALLOC () {1;}' unless defined(&ATTRIBUTE_MALLOC);
	}
    }
    unless(defined(&ATTRIBUTE_UNUSED_LABEL)) {
	if((!defined ( &__cplusplus)  && (defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 2093)) {
	    eval 'sub ATTRIBUTE_UNUSED_LABEL () { &ATTRIBUTE_UNUSED;}' unless defined(&ATTRIBUTE_UNUSED_LABEL);
	} else {
	    eval 'sub ATTRIBUTE_UNUSED_LABEL () {1;}' unless defined(&ATTRIBUTE_UNUSED_LABEL);
	}
    }
    unless(defined(&ATTRIBUTE_UNUSED)) {
	eval 'sub ATTRIBUTE_UNUSED () { &__attribute__ (( &__unused__));}' unless defined(&ATTRIBUTE_UNUSED);
    }
    if(! defined( &__cplusplus) || ((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 3004)) {
	eval 'sub ARG_UNUSED {
	    my($NAME) = @_;
    	    eval q($NAME  &ATTRIBUTE_UNUSED);
	}' unless defined(&ARG_UNUSED);
    } else {
	eval 'sub ARG_UNUSED {
	    my($NAME) = @_;
    	    eval q($NAME);
	}' unless defined(&ARG_UNUSED);
    }
    unless(defined(&ATTRIBUTE_NORETURN)) {
	eval 'sub ATTRIBUTE_NORETURN () { &__attribute__ (( &__noreturn__));}' unless defined(&ATTRIBUTE_NORETURN);
    }
    unless(defined(&ATTRIBUTE_NONNULL)) {
	if(((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 3003)) {
	    eval 'sub ATTRIBUTE_NONNULL {
	        my($m) = @_;
    		eval q( &__attribute__ (( &__nonnull__ ($m))));
	    }' unless defined(&ATTRIBUTE_NONNULL);
	} else {
	    eval 'sub ATTRIBUTE_NONNULL {
	        my($m) = @_;
    		eval q();
	    }' unless defined(&ATTRIBUTE_NONNULL);
	}
    }
    unless(defined(&ATTRIBUTE_PURE)) {
	if(((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 3000)) {
	    eval 'sub ATTRIBUTE_PURE () { &__attribute__ (( &__pure__));}' unless defined(&ATTRIBUTE_PURE);
	} else {
	    eval 'sub ATTRIBUTE_PURE () {1;}' unless defined(&ATTRIBUTE_PURE);
	}
    }
    unless(defined(&ATTRIBUTE_PRINTF)) {
	eval 'sub ATTRIBUTE_PRINTF {
	    my($m, $n) = @_;
    	    eval q( &__attribute__ (( &__format__ ( &__printf__, $m, $n)))  &ATTRIBUTE_NONNULL($m));
	}' unless defined(&ATTRIBUTE_PRINTF);
	eval 'sub ATTRIBUTE_PRINTF_1 () { &ATTRIBUTE_PRINTF(1, 2);}' unless defined(&ATTRIBUTE_PRINTF_1);
	eval 'sub ATTRIBUTE_PRINTF_2 () { &ATTRIBUTE_PRINTF(2, 3);}' unless defined(&ATTRIBUTE_PRINTF_2);
	eval 'sub ATTRIBUTE_PRINTF_3 () { &ATTRIBUTE_PRINTF(3, 4);}' unless defined(&ATTRIBUTE_PRINTF_3);
	eval 'sub ATTRIBUTE_PRINTF_4 () { &ATTRIBUTE_PRINTF(4, 5);}' unless defined(&ATTRIBUTE_PRINTF_4);
	eval 'sub ATTRIBUTE_PRINTF_5 () { &ATTRIBUTE_PRINTF(5, 6);}' unless defined(&ATTRIBUTE_PRINTF_5);
    }
    unless(defined(&ATTRIBUTE_FPTR_PRINTF)) {
	if(((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 3001)) {
	    eval 'sub ATTRIBUTE_FPTR_PRINTF {
	        my($m, $n) = @_;
    		eval q( &ATTRIBUTE_PRINTF($m, $n));
	    }' unless defined(&ATTRIBUTE_FPTR_PRINTF);
	} else {
	    eval 'sub ATTRIBUTE_FPTR_PRINTF {
	        my($m, $n) = @_;
    		eval q();
	    }' unless defined(&ATTRIBUTE_FPTR_PRINTF);
	}
	eval 'sub ATTRIBUTE_FPTR_PRINTF_1 () { &ATTRIBUTE_FPTR_PRINTF(1, 2);}' unless defined(&ATTRIBUTE_FPTR_PRINTF_1);
	eval 'sub ATTRIBUTE_FPTR_PRINTF_2 () { &ATTRIBUTE_FPTR_PRINTF(2, 3);}' unless defined(&ATTRIBUTE_FPTR_PRINTF_2);
	eval 'sub ATTRIBUTE_FPTR_PRINTF_3 () { &ATTRIBUTE_FPTR_PRINTF(3, 4);}' unless defined(&ATTRIBUTE_FPTR_PRINTF_3);
	eval 'sub ATTRIBUTE_FPTR_PRINTF_4 () { &ATTRIBUTE_FPTR_PRINTF(4, 5);}' unless defined(&ATTRIBUTE_FPTR_PRINTF_4);
	eval 'sub ATTRIBUTE_FPTR_PRINTF_5 () { &ATTRIBUTE_FPTR_PRINTF(5, 6);}' unless defined(&ATTRIBUTE_FPTR_PRINTF_5);
    }
    unless(defined(&ATTRIBUTE_NULL_PRINTF)) {
	if(((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 3003)) {
	    eval 'sub ATTRIBUTE_NULL_PRINTF {
	        my($m, $n) = @_;
    		eval q( &__attribute__ (( &__format__ ( &__printf__, $m, $n))));
	    }' unless defined(&ATTRIBUTE_NULL_PRINTF);
	} else {
	    eval 'sub ATTRIBUTE_NULL_PRINTF {
	        my($m, $n) = @_;
    		eval q();
	    }' unless defined(&ATTRIBUTE_NULL_PRINTF);
	}
	eval 'sub ATTRIBUTE_NULL_PRINTF_1 () { &ATTRIBUTE_NULL_PRINTF(1, 2);}' unless defined(&ATTRIBUTE_NULL_PRINTF_1);
	eval 'sub ATTRIBUTE_NULL_PRINTF_2 () { &ATTRIBUTE_NULL_PRINTF(2, 3);}' unless defined(&ATTRIBUTE_NULL_PRINTF_2);
	eval 'sub ATTRIBUTE_NULL_PRINTF_3 () { &ATTRIBUTE_NULL_PRINTF(3, 4);}' unless defined(&ATTRIBUTE_NULL_PRINTF_3);
	eval 'sub ATTRIBUTE_NULL_PRINTF_4 () { &ATTRIBUTE_NULL_PRINTF(4, 5);}' unless defined(&ATTRIBUTE_NULL_PRINTF_4);
	eval 'sub ATTRIBUTE_NULL_PRINTF_5 () { &ATTRIBUTE_NULL_PRINTF(5, 6);}' unless defined(&ATTRIBUTE_NULL_PRINTF_5);
    }
    unless(defined(&ATTRIBUTE_SENTINEL)) {
	if(((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 3005)) {
	    eval 'sub ATTRIBUTE_SENTINEL () { &__attribute__ (( &__sentinel__));}' unless defined(&ATTRIBUTE_SENTINEL);
	} else {
	    eval 'sub ATTRIBUTE_SENTINEL () {1;}' unless defined(&ATTRIBUTE_SENTINEL);
	}
    }
    unless(defined(&ATTRIBUTE_ALIGNED_ALIGNOF)) {
	if(((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 3000)) {
	    eval 'sub ATTRIBUTE_ALIGNED_ALIGNOF {
	        my($m) = @_;
    		eval q( &__attribute__ (( &__aligned__ ( &__alignof__ ($m)))));
	    }' unless defined(&ATTRIBUTE_ALIGNED_ALIGNOF);
	} else {
	    eval 'sub ATTRIBUTE_ALIGNED_ALIGNOF {
	        my($m) = @_;
    		eval q();
	    }' unless defined(&ATTRIBUTE_ALIGNED_ALIGNOF);
	}
    }
    unless(defined(&ATTRIBUTE_PACKED)) {
	eval 'sub ATTRIBUTE_PACKED () { &__attribute__ (( &packed));}' unless defined(&ATTRIBUTE_PACKED);
    }
    unless(defined(&ATTRIBUTE_COLD)) {
	if(((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 4003)) {
	    eval 'sub ATTRIBUTE_COLD () { &__attribute__ (( &__cold__));}' unless defined(&ATTRIBUTE_COLD);
	} else {
	    eval 'sub ATTRIBUTE_COLD () {1;}' unless defined(&ATTRIBUTE_COLD);
	}
    }
    unless(defined(&ATTRIBUTE_HOT)) {
	if(((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 4003)) {
	    eval 'sub ATTRIBUTE_HOT () { &__attribute__ (( &__hot__));}' unless defined(&ATTRIBUTE_HOT);
	} else {
	    eval 'sub ATTRIBUTE_HOT () {1;}' unless defined(&ATTRIBUTE_HOT);
	}
    }
    if((defined(&GCC_VERSION) ? &GCC_VERSION : 0) < 2008) {
	eval 'sub __extension__ () {1;}' unless defined(&__extension__);
    }
}
1;
