require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_UCLIBC_MUTEX_H)) {
    eval 'sub _UCLIBC_MUTEX_H () {1;}' unless defined(&_UCLIBC_MUTEX_H);
    require 'features.ph';
    if(defined(&__UCLIBC_HAS_THREADS__)) {
	unless(defined(&_GNU_SOURCE)) {
	    eval 'sub _GNU_SOURCE () {1;}' unless defined(&_GNU_SOURCE);
	}
	require 'pthread.ph';
	require 'bits/uClibc_pthread.ph';
	eval 'sub __UCLIBC_MUTEX_TYPE () { &pthread_mutex_t;}' unless defined(&__UCLIBC_MUTEX_TYPE);
	eval 'sub __UCLIBC_MUTEX {
	    my($M) = @_;
    	    eval q( &pthread_mutex_t $M);
	}' unless defined(&__UCLIBC_MUTEX);
	eval 'sub __UCLIBC_MUTEX_INIT {
	    my($M,$I) = @_;
    	    eval q( &pthread_mutex_t $M = $I);
	}' unless defined(&__UCLIBC_MUTEX_INIT);
	eval 'sub __UCLIBC_MUTEX_STATIC {
	    my($M,$I) = @_;
    	    eval q( &static  &pthread_mutex_t $M = $I);
	}' unless defined(&__UCLIBC_MUTEX_STATIC);
	eval 'sub __UCLIBC_MUTEX_EXTERN {
	    my($M) = @_;
    	    eval q( &extern  &pthread_mutex_t $M);
	}' unless defined(&__UCLIBC_MUTEX_EXTERN);
	eval 'sub __UCLIBC_MUTEX_LOCK_CANCEL_UNSAFE {
	    my($M) = @_;
    	    eval q( &__pthread_mutex_lock(($M)));
	}' unless defined(&__UCLIBC_MUTEX_LOCK_CANCEL_UNSAFE);
	eval 'sub __UCLIBC_MUTEX_UNLOCK_CANCEL_UNSAFE {
	    my($M) = @_;
    	    eval q( &__pthread_mutex_unlock(($M)));
	}' unless defined(&__UCLIBC_MUTEX_UNLOCK_CANCEL_UNSAFE);
	eval 'sub __UCLIBC_MUTEX_TRYLOCK_CANCEL_UNSAFE {
	    my($M) = @_;
    	    eval q( &__pthread_mutex_trylock(($M)));
	}' unless defined(&__UCLIBC_MUTEX_TRYLOCK_CANCEL_UNSAFE);
	eval 'sub __UCLIBC_MUTEX_CONDITIONAL_LOCK {
	    my($M,$C) = @_;
    	    eval q( &do { \'struct _pthread_cleanup_buffer\'  &__infunc_pthread_cleanup_buffer;  &if ($C) {  &_pthread_cleanup_push_defer(& &__infunc_pthread_cleanup_buffer, ( &void (*) ( &void *)) &__pthread_mutex_unlock, ($M));  &__pthread_mutex_lock(($M)); } (( &void)0));
	}' unless defined(&__UCLIBC_MUTEX_CONDITIONAL_LOCK);
	eval 'sub __UCLIBC_MUTEX_CONDITIONAL_UNLOCK {
	    my($M,$C) = @_;
    	    eval q( &if ($C) {  &_pthread_cleanup_pop_restore(& &__infunc_pthread_cleanup_buffer,1); } }  &while (0));
	}' unless defined(&__UCLIBC_MUTEX_CONDITIONAL_UNLOCK);
	eval 'sub __UCLIBC_MUTEX_AUTO_LOCK_VAR {
	    my($A) = @_;
    	    eval q(\'int\' $A);
	}' unless defined(&__UCLIBC_MUTEX_AUTO_LOCK_VAR);
	eval 'sub __UCLIBC_MUTEX_AUTO_LOCK {
	    my($M,$A,$V) = @_;
    	    eval q( &__UCLIBC_MUTEX_CONDITIONAL_LOCK($M,(($A=($V)) == 0)));
	}' unless defined(&__UCLIBC_MUTEX_AUTO_LOCK);
	eval 'sub __UCLIBC_MUTEX_AUTO_UNLOCK {
	    my($M,$A) = @_;
    	    eval q( &__UCLIBC_MUTEX_CONDITIONAL_UNLOCK($M,($A == 0)));
	}' unless defined(&__UCLIBC_MUTEX_AUTO_UNLOCK);
	eval 'sub __UCLIBC_MUTEX_LOCK {
	    my($M) = @_;
    	    eval q( &__UCLIBC_MUTEX_CONDITIONAL_LOCK($M, 1));
	}' unless defined(&__UCLIBC_MUTEX_LOCK);
	eval 'sub __UCLIBC_MUTEX_UNLOCK {
	    my($M) = @_;
    	    eval q( &__UCLIBC_MUTEX_CONDITIONAL_UNLOCK($M, 1));
	}' unless defined(&__UCLIBC_MUTEX_UNLOCK);
    } else {
	eval 'sub __UCLIBC_MUTEX {
	    my($M) = @_;
    	    eval q( &void * &__UCLIBC_MUTEX_DUMMY_  $M);
	}' unless defined(&__UCLIBC_MUTEX);
	eval 'sub __UCLIBC_MUTEX_INIT {
	    my($M,$I) = @_;
    	    eval q( &extern  &void * &__UCLIBC_MUTEX_DUMMY_  $M);
	}' unless defined(&__UCLIBC_MUTEX_INIT);
	eval 'sub __UCLIBC_MUTEX_STATIC {
	    my($M,$I) = @_;
    	    eval q( &extern  &void * &__UCLIBC_MUTEX_DUMMY_  $M);
	}' unless defined(&__UCLIBC_MUTEX_STATIC);
	eval 'sub __UCLIBC_MUTEX_EXTERN {
	    my($M) = @_;
    	    eval q( &extern  &void * &__UCLIBC_MUTEX_DUMMY_  $M);
	}' unless defined(&__UCLIBC_MUTEX_EXTERN);
	eval 'sub __UCLIBC_MUTEX_LOCK_CANCEL_UNSAFE {
	    my($M) = @_;
    	    eval q((( &void)0));
	}' unless defined(&__UCLIBC_MUTEX_LOCK_CANCEL_UNSAFE);
	eval 'sub __UCLIBC_MUTEX_UNLOCK_CANCEL_UNSAFE {
	    my($M) = @_;
    	    eval q((( &void)0));
	}' unless defined(&__UCLIBC_MUTEX_UNLOCK_CANCEL_UNSAFE);
	eval 'sub __UCLIBC_MUTEX_TRYLOCK_CANCEL_UNSAFE {
	    my($M) = @_;
    	    eval q((0));
	}' unless defined(&__UCLIBC_MUTEX_TRYLOCK_CANCEL_UNSAFE);
	eval 'sub __UCLIBC_MUTEX_CONDITIONAL_LOCK {
	    my($M,$C) = @_;
    	    eval q((( &void)0));
	}' unless defined(&__UCLIBC_MUTEX_CONDITIONAL_LOCK);
	eval 'sub __UCLIBC_MUTEX_CONDITIONAL_UNLOCK {
	    my($M,$C) = @_;
    	    eval q((( &void)0));
	}' unless defined(&__UCLIBC_MUTEX_CONDITIONAL_UNLOCK);
	eval 'sub __UCLIBC_MUTEX_AUTO_LOCK_VAR {
	    my($A) = @_;
    	    eval q((( &void)0));
	}' unless defined(&__UCLIBC_MUTEX_AUTO_LOCK_VAR);
	eval 'sub __UCLIBC_MUTEX_AUTO_LOCK {
	    my($M,$A,$V) = @_;
    	    eval q((( &void)0));
	}' unless defined(&__UCLIBC_MUTEX_AUTO_LOCK);
	eval 'sub __UCLIBC_MUTEX_AUTO_UNLOCK {
	    my($M,$A) = @_;
    	    eval q((( &void)0));
	}' unless defined(&__UCLIBC_MUTEX_AUTO_UNLOCK);
	eval 'sub __UCLIBC_MUTEX_LOCK {
	    my($M) = @_;
    	    eval q((( &void)0));
	}' unless defined(&__UCLIBC_MUTEX_LOCK);
	eval 'sub __UCLIBC_MUTEX_UNLOCK {
	    my($M) = @_;
    	    eval q((( &void)0));
	}' unless defined(&__UCLIBC_MUTEX_UNLOCK);
    }
}
1;
