require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&LIBIBERTY_H)) {
    eval 'sub LIBIBERTY_H () {1;}' unless defined(&LIBIBERTY_H);
    if(defined(&__cplusplus)) {
    }
    require 'ansidecl.ph';
    require 'stddef.ph';
    require 'stdarg.ph';
    require 'stdio.ph';
    if(!(defined(&HAVE_DECL_BASENAME) ? &HAVE_DECL_BASENAME : 0)) {
	if(defined ( &__GNU_LIBRARY__ ) || defined ( &__linux__) || defined ( &__FreeBSD__) || defined ( &__OpenBSD__) || defined( &__NetBSD__) || defined ( &__CYGWIN__) || defined ( &__CYGWIN32__) || defined ( &__MINGW32__) || defined ( &HAVE_DECL_BASENAME)) {
	} else {
	    eval 'sub basename () { &basename_cannot_be_used_without_a_prototype;}' unless defined(&basename);
	}
    }
    eval 'sub ACONCAT {
        my($ACONCAT_PARAMS) = @_;
	    eval q(( &libiberty_concat_ptr =  &alloca ( &concat_length $ACONCAT_PARAMS + 1),  &concat_copy2 $ACONCAT_PARAMS));
    }' unless defined(&ACONCAT);
    if(defined ( &HAVE_DECL_FFS)  && !(defined(&HAVE_DECL_FFS) ? &HAVE_DECL_FFS : 0)) {
    }
    if(defined(&__MINGW32__)) {
    }
    eval 'sub XNEW {
        my($T) = @_;
	    eval q((($T *)  &xmalloc ($sizeof{$T})));
    }' unless defined(&XNEW);
    eval 'sub XCNEW {
        my($T) = @_;
	    eval q((($T *)  &xcalloc (1, $sizeof{$T})));
    }' unless defined(&XCNEW);
    eval 'sub XDELETE {
        my($P) = @_;
	    eval q( &free (( &void*) ($P)));
    }' unless defined(&XDELETE);
    eval 'sub XNEWVEC {
        my($T, $N) = @_;
	    eval q((($T *)  &xmalloc ($sizeof{$T} * ($N))));
    }' unless defined(&XNEWVEC);
    eval 'sub XCNEWVEC {
        my($T, $N) = @_;
	    eval q((($T *)  &xcalloc (($N), $sizeof{$T})));
    }' unless defined(&XCNEWVEC);
    eval 'sub XRESIZEVEC {
        my($T, $P, $N) = @_;
	    eval q((($T *)  &xrealloc (( &void *) ($P), $sizeof{$T} * ($N))));
    }' unless defined(&XRESIZEVEC);
    eval 'sub XDELETEVEC {
        my($P) = @_;
	    eval q( &free (( &void*) ($P)));
    }' unless defined(&XDELETEVEC);
    eval 'sub XNEWVAR {
        my($T, $S) = @_;
	    eval q((($T *)  &xmalloc (($S))));
    }' unless defined(&XNEWVAR);
    eval 'sub XCNEWVAR {
        my($T, $S) = @_;
	    eval q((($T *)  &xcalloc (1, ($S))));
    }' unless defined(&XCNEWVAR);
    eval 'sub XRESIZEVAR {
        my($T, $P, $S) = @_;
	    eval q((($T *)  &xrealloc (($P), ($S))));
    }' unless defined(&XRESIZEVAR);
    eval 'sub XOBNEW {
        my($O, $T) = @_;
	    eval q((($T *)  &obstack_alloc (($O), $sizeof{$T})));
    }' unless defined(&XOBNEW);
    eval 'sub XOBFINISH {
        my($O, $T) = @_;
	    eval q((($T)  &obstack_finish (($O))));
    }' unless defined(&XOBFINISH);
    eval 'sub _hex_array_size () {256;}' unless defined(&_hex_array_size);
    eval 'sub _hex_bad () {99;}' unless defined(&_hex_bad);
    eval 'sub hex_p {
        my($c) = @_;
	    eval q(( &hex_value ($c) !=  &_hex_bad));
    }' unless defined(&hex_p);
    eval 'sub hex_value {
        my($c) = @_;
	    eval q((  $_hex_value[ ($c)]));
    }' unless defined(&hex_value);
    eval 'sub PEX_RECORD_TIMES () {0x1;}' unless defined(&PEX_RECORD_TIMES);
    eval 'sub PEX_USE_PIPES () {0x2;}' unless defined(&PEX_USE_PIPES);
    eval 'sub PEX_SAVE_TEMPS () {0x4;}' unless defined(&PEX_SAVE_TEMPS);
    eval 'sub PEX_LAST () {0x1;}' unless defined(&PEX_LAST);
    eval 'sub PEX_SEARCH () {0x2;}' unless defined(&PEX_SEARCH);
    eval 'sub PEX_SUFFIX () {0x4;}' unless defined(&PEX_SUFFIX);
    eval 'sub PEX_STDERR_TO_STDOUT () {0x8;}' unless defined(&PEX_STDERR_TO_STDOUT);
    eval 'sub PEX_BINARY_INPUT () {0x10;}' unless defined(&PEX_BINARY_INPUT);
    eval 'sub PEX_BINARY_OUTPUT () {0x20;}' unless defined(&PEX_BINARY_OUTPUT);
    eval 'sub PEX_STDERR_TO_PIPE () {0x40;}' unless defined(&PEX_STDERR_TO_PIPE);
    eval 'sub PEX_BINARY_ERROR () {0x80;}' unless defined(&PEX_BINARY_ERROR);
    eval 'sub PEXECUTE_FIRST () {1;}' unless defined(&PEXECUTE_FIRST);
    eval 'sub PEXECUTE_LAST () {2;}' unless defined(&PEXECUTE_LAST);
    eval 'sub PEXECUTE_ONE () {( &PEXECUTE_FIRST +  &PEXECUTE_LAST);}' unless defined(&PEXECUTE_ONE);
    eval 'sub PEXECUTE_SEARCH () {4;}' unless defined(&PEXECUTE_SEARCH);
    eval 'sub PEXECUTE_VERBOSE () {8;}' unless defined(&PEXECUTE_VERBOSE);
    if(!(defined(&HAVE_DECL_ASPRINTF) ? &HAVE_DECL_ASPRINTF : 0)) {
    }
    if(!(defined(&HAVE_DECL_VASPRINTF) ? &HAVE_DECL_VASPRINTF : 0)) {
    }
    if(defined( &HAVE_DECL_SNPRINTF)  && !(defined(&HAVE_DECL_SNPRINTF) ? &HAVE_DECL_SNPRINTF : 0)) {
    }
    if(defined( &HAVE_DECL_VSNPRINTF)  && !(defined(&HAVE_DECL_VSNPRINTF) ? &HAVE_DECL_VSNPRINTF : 0)) {
    }
    if(defined( &HAVE_DECL_STRVERSCMP)  && !(defined(&HAVE_DECL_STRVERSCMP) ? &HAVE_DECL_STRVERSCMP : 0)) {
    }
    eval 'sub ARRAY_SIZE {
        my($a) = @_;
	    eval q(($sizeof{$a} / $sizeof{($a)[0]}));
    }' unless defined(&ARRAY_SIZE);
    undef(&alloca) if defined(&alloca);
    if((defined(&GCC_VERSION) ? &GCC_VERSION : 0) >= 2000 && !defined (defined(&USE_C_ALLOCA) ? &USE_C_ALLOCA : 0)) {
	eval 'sub alloca {
	    my($x) = @_;
    	    eval q( &__builtin_alloca($x));
	}' unless defined(&alloca);
	undef(&C_ALLOCA) if defined(&C_ALLOCA);
	eval 'sub ASTRDUP {
	    my($X) = @_;
    	    eval q(( &__extension__ ({  &const \'char\' * &const  &libiberty_optr = ;  &const \'unsigned long libiberty_len\' =  &strlen + 1; \'char\' * &const  &libiberty_nptr = (\'char\' * &const)  &alloca ;  &memcpy ( &libiberty_nptr,  &libiberty_optr,  &libiberty_len); })));
	}' unless defined(&ASTRDUP);
    } else {
	eval 'sub alloca {
	    my($x) = @_;
    	    eval q( &C_alloca($x));
	}' unless defined(&alloca);
	undef(&USE_C_ALLOCA) if defined(&USE_C_ALLOCA);
	eval 'sub USE_C_ALLOCA () {1;}' unless defined(&USE_C_ALLOCA);
	undef(&C_ALLOCA) if defined(&C_ALLOCA);
	eval 'sub C_ALLOCA () {1;}' unless defined(&C_ALLOCA);
	eval 'sub ASTRDUP {
	    my($X) = @_;
    	    eval q(( &libiberty_optr = ,  &libiberty_len =  &strlen + 1,  &libiberty_nptr =  &alloca ,  &memcpy ( &libiberty_nptr,  &libiberty_optr,  &libiberty_len)));
	}' unless defined(&ASTRDUP);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
